##########
# FORMAT #
##########

# All arguments are optional.
# Only the keys in this list are interpreted, the others are ignored.
# Each list item (start with '-') can be duplicated as many times as necessary.
# The easiest way to create a new configuration is to copy this document and modify it.

name: ws-wfcatalog

# BASE
port: 3000
url: /eidaws/wfcatalog/1/(.*)
containers:
  - name: init-config
    image: dibi/envsubst
  - image: gricad-registry.univ-grenoble-alpes.fr/osug/resif/resif-wfcatalog/ws
    tag: 4e8b3240
    port: 3000
    cpu_limit: 500m
    mem_limit: 128Mi


# ENVIRONMENTS
contexts:
  - name: staging
    containers:
      - env:
          RUNMODE: staging # preprod
      - name: init-config
        secrets:
          MONGODB_PASSWORD: mongodbpass
    host: ws-staging.resif.fr
  - name: production
    containers:
      - env:
          RUNMODE: production
        cpu_request: 500m
        mem_request: 128Mi
      - name: init-config
        secrets:
          MONGODB_PASSWORD: mongodbpass
    host: ws.resif.fr


# TODO: Add in deployment.yaml
spec.template.spec:
  initContainers:
    # This container will use the configuration file from the configmap and replace $MONGODB_PASSWORD by the value
    # from it's environment variable.
    # The result is pushed in a new mountpoint used by the main container
    - volumeMounts:
        - name: config
          mountPath: /processed
        - name: init-workdir
          mountPath: /workdir
  containers[0]:
    volumeMounts:
      - name: config
        mountPath: /app/configuration.json
        # subPath allows to put just this fine in an already existing directory
        subPath: configuration.json
  volumes:
    - name: init-workdir
      configMap:
        name: ws-wfcatalog
        items:
          - key: config
            path: configuration.json
    - name: config
      emptyDir: {}
# TODO: Move 'init-config' from 'containers' to 'initContainers' in deployment.yaml

# TODO: Delete envFrom in InitContainer

# TODO: Move 'init-config' from 'containers' to 'initContainers' in both kustomization.yaml

# TODO: Delete configmapgenerator and add path to configmap

# TODO: replace secrets patch container -> init container

